"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }var _base = require('@gregnr/postgres-meta/base');var _mcputils = require('@supabase/mcp-utils');var _zod = require('zod');var c="0.1.0-dev.1";var _openapifetch = require('openapi-fetch'); var _openapifetch2 = _interopRequireDefault(_openapifetch);function l(i,p,a={}){return _openapifetch2.default.call(void 0, {baseUrl:i,headers:{"Content-Type":"application/json",Authorization:`Bearer ${p}`,...a}})}function z(i){let p=_nullishCoalesce(i.platform.apiUrl, () => ("https://api.supabase.com")),a;async function d(e,r){let s=await a.POST("/v1/projects/{ref}/database/query",{params:{path:{ref:e}},body:{query:r}});if(!s.response.ok)throw new Error("Failed to execute SQL query");return s.data}function u(e){return new (0, _base.PostgresMetaBase)({query:async r=>{try{let s=await d(e,r);return _base.wrapResult.call(void 0, s)}catch(s){return _base.wrapError.call(void 0, s,r)}},end:async()=>{}})}return _mcputils.createMcpServer.call(void 0, {name:"supabase",version:c,onInitialize(e){a=l(p,i.platform.accessToken,{"User-Agent":`supabase-mcp/${c} (${e.name}/${e.version})`})},tools:{get_projects:_mcputils.tool.call(void 0, {description:"Gets all Supabase projects for the user.",parameters:_zod.z.object({}),execute:async()=>{let e=await a.GET("/v1/projects");if(!e.response.ok)throw new Error("Failed to fetch projects");return e.data}}),get_organizations:_mcputils.tool.call(void 0, {description:"Gets all organizations for the user.",parameters:_zod.z.object({}),execute:async()=>{let e=await a.GET("/v1/organizations");if(!e.response.ok)throw new Error("Failed to fetch organizations");return e.data}}),get_organization:_mcputils.tool.call(void 0, {description:"Gets an organization by ID.",parameters:_zod.z.object({id:_zod.z.string().describe("The organization ID")}),execute:async({id:e})=>{let r=await a.GET("/v1/organizations/{slug}",{params:{path:{slug:e}}});if(!r.response.ok)throw new Error("Failed to fetch organization");return r.data}}),get_tables:_mcputils.tool.call(void 0, {description:"Gets all tables in a schema.",parameters:_zod.z.object({projectId:_zod.z.string(),schemas:_zod.z.optional(_zod.z.array(_zod.z.string())).describe("Optional list of schemas to include. Defaults to all schemas.")}),execute:async({projectId:e,schemas:r})=>{let s=u(e),{data:o,error:m}=await s.tables.list({includedSchemas:r});if(m)throw new Error(`Error fetching tables: ${m.message}`);return o}}),get_extensions:_mcputils.tool.call(void 0, {description:"Gets all extensions in the database.",parameters:_zod.z.object({projectId:_zod.z.string()}),execute:async({projectId:e})=>{let r=u(e),{data:s,error:o}=await r.extensions.list();if(o)throw new Error(`Error fetching extensions: ${o.message}`);return s}}),apply_migration:_mcputils.tool.call(void 0, {description:"Applies a migration to the database. Use this when executing DDL operations.",parameters:_zod.z.object({projectId:_zod.z.string(),name:_zod.z.string().describe("The name of the migration in snake_case"),query:_zod.z.string().describe("The SQL query to apply")}),execute:async({projectId:e,name:r,query:s})=>{let o=await a.POST("/v1/projects/{ref}/database/migrations",{params:{path:{ref:e}},body:{name:r,query:s}});if(!o.response.ok)throw new Error("Failed to apply migration");return o.data}}),execute_sql:_mcputils.tool.call(void 0, {description:"Executes raw SQL in the Postgres database. Use `applyMigration` instead for DDL operations.",parameters:_zod.z.object({projectId:_zod.z.string(),query:_zod.z.string().describe("The SQL query to execute")}),execute:async({query:e,projectId:r})=>await d(r,e)}),get_project_url:_mcputils.tool.call(void 0, {description:"Gets the API URL for a project.",parameters:_zod.z.object({projectId:_zod.z.string()}),execute:async({projectId:e})=>`https://${e}.supabase.co`}),get_anon_key:_mcputils.tool.call(void 0, {description:"Gets the anonymous API key for a project.",parameters:_zod.z.object({projectId:_zod.z.string()}),execute:async({projectId:e})=>{let r=await a.GET("/v1/projects/{ref}/api-keys",{params:{path:{ref:e},query:{reveal:!1}}});if(!r.response.ok)throw new Error("Failed to fetch API keys");let s=_optionalChain([r, 'access', _ => _.data, 'optionalAccess', _2 => _2.find, 'call', _3 => _3(o=>o.name==="anon")]);if(!s)throw new Error("Anonymous key not found");return s.api_key}}),generate_typescript_types:_mcputils.tool.call(void 0, {description:"Generates TypeScript types for a project.",parameters:_zod.z.object({projectId:_zod.z.string()}),execute:async({projectId:e})=>{let r=await a.GET("/v1/projects/{ref}/types/typescript",{params:{path:{ref:e}}});if(!r.response.ok)throw new Error("Failed to fetch TypeScript types");return r.data}})}})}exports.a = z;
//# sourceMappingURL=chunk-5UWVQOB5.cjs.map